Package com.io7m.cardant.parsers

# Class CAExpressions

java.lang.Object
com.io7m.cardant.parsers.CAExpressions

Direct Known Subclasses:
  `CAConstraintExpressions`, `CAItemLocationMatchExpressions`, `CAMetadataExpressions`, `CAMetadataMatchExpressions`, `CANameMatchExpressions`, `CATypeMatchExpressions`

public abstract class CAExpressions extends Object
The base type of expression parsers.

- ## Constructor Summary

  Constructors
  Modifier
  Constructor
  Description
  `protected`
  `CAExpressions(CAStrings inStrings)`

- ## Method Summary

  Modifier and Type
  Method
  Description
  `protected final CAException`
  `createParseError(com.io7m.jsx.SExpressionType expression)`
  `protected final CAException`
  `createParseError(com.io7m.jsx.SExpressionType expression, Exception e)`
  `static com.io7m.jsx.SExpressionType`
  `parse(String text)`
  Parse text as an s-expression.
  `static String`
  `serialize(com.io7m.jsx.SExpressionType expression)`
  Serialize an expression to a string.
  `protected abstract Map<CAStringConstantType,CAStringConstantType>`
  `syntax()`

  ### Methods inherited from class java.lang.Object

  `clone, equals, finalize, getClass, hashCode, notify, notifyAll, toString, wait, wait, wait`

- ## Constructor Details

  - ### CAExpressions

    protected CAExpressions(CAStrings inStrings)

- ## Method Details

  - ### serialize

    public static String serialize(com.io7m.jsx.SExpressionType expression) throws CAException
    Serialize an expression to a string.
    Parameters:
      `expression` - The expression
    Returns:
      The serialized expression
    Throws:
      `CAException` - On errors

  - ### parse

    public static com.io7m.jsx.SExpressionType parse(String text) throws CAException
    Parse text as an s-expression.
    Parameters:
      `text` - The text
    Returns:
      The parsed expression
    Throws:
      `CAException` - On errors

  - ### syntax

    protected abstract Map<CAStringConstantType,CAStringConstantType> syntax()

  - ### createParseError

    protected final CAException createParseError(com.io7m.jsx.SExpressionType expression)

  - ### createParseError

    protected final CAException createParseError(com.io7m.jsx.SExpressionType expression, Exception e)